<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglCombiner&lt; ALG_MESSAGE_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classtiglCombiner-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">tiglCombiner&lt; ALG_MESSAGE_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__interface__engine.html">Interface</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>pure combiner class for the <a class="el" href="classTIGL.html" title="Top level class for the TIGL engine  . ">TIGL</a> engine  
 <a href="classtiglCombiner.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglAPICombiner_8hpp_source.html">tiglAPICombiner.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a1560621c6a9ed136834bac2e60606ed5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1560621c6a9ed136834bac2e60606ed5"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#a1560621c6a9ed136834bac2e60606ed5">tiglCombiner</a> ()</td></tr>
<tr class="memdesc:a1560621c6a9ed136834bac2e60606ed5"><td class="mdescLeft">&#160;</td><td class="mdescRight">contsructor <br /></td></tr>
<tr class="separator:a1560621c6a9ed136834bac2e60606ed5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a912f4f3be9f0e53c323832cfb1b4a0ef"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a912f4f3be9f0e53c323832cfb1b4a0ef"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#a912f4f3be9f0e53c323832cfb1b4a0ef">~tiglCombiner</a> ()</td></tr>
<tr class="memdesc:a912f4f3be9f0e53c323832cfb1b4a0ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">destructor <br /></td></tr>
<tr class="separator:a912f4f3be9f0e53c323832cfb1b4a0ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecd9b18389735ebab5354a9a192e4020"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#aecd9b18389735ebab5354a9a192e4020">combineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:aecd9b18389735ebab5354a9a192e4020"><td class="mdescLeft">&#160;</td><td class="mdescRight">core combine function for multiple messages.  <a href="#aecd9b18389735ebab5354a9a192e4020">More...</a><br /></td></tr>
<tr class="separator:aecd9b18389735ebab5354a9a192e4020"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a753c1c8803743ac43e91f19975b30af2"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#a753c1c8803743ac43e91f19975b30af2">combineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a753c1c8803743ac43e91f19975b30af2"><td class="mdescLeft">&#160;</td><td class="mdescRight">core combine function from combining a single message.  <a href="#a753c1c8803743ac43e91f19975b30af2">More...</a><br /></td></tr>
<tr class="separator:a753c1c8803743ac43e91f19975b30af2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4eebe24c6a26fc98148940065ac9c5b"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#aa4eebe24c6a26fc98148940065ac9c5b">sumCombineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:aa4eebe24c6a26fc98148940065ac9c5b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sum combine function.  <a href="#aa4eebe24c6a26fc98148940065ac9c5b">More...</a><br /></td></tr>
<tr class="separator:aa4eebe24c6a26fc98148940065ac9c5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad9bacc561b203b7abe26a0175fe6d46a"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#ad9bacc561b203b7abe26a0175fe6d46a">sumCombineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:ad9bacc561b203b7abe26a0175fe6d46a"><td class="mdescLeft">&#160;</td><td class="mdescRight">implementation of sum combine function for adding a single message.  <a href="#ad9bacc561b203b7abe26a0175fe6d46a">More...</a><br /></td></tr>
<tr class="separator:ad9bacc561b203b7abe26a0175fe6d46a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2206471de99d722dac790f6ed9b44d08"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#a2206471de99d722dac790f6ed9b44d08">maxCombineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a2206471de99d722dac790f6ed9b44d08"><td class="mdescLeft">&#160;</td><td class="mdescRight">Maximum combine function.  <a href="#a2206471de99d722dac790f6ed9b44d08">More...</a><br /></td></tr>
<tr class="separator:a2206471de99d722dac790f6ed9b44d08"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a075730c5510d5998da3e1200b3f3c7a5"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#a075730c5510d5998da3e1200b3f3c7a5">maxCombineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a075730c5510d5998da3e1200b3f3c7a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Max combine function for adding a single message.  <a href="#a075730c5510d5998da3e1200b3f3c7a5">More...</a><br /></td></tr>
<tr class="separator:a075730c5510d5998da3e1200b3f3c7a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5dffd8924866931c4092ae85a869b49e"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#a5dffd8924866931c4092ae85a869b49e">minCombineMessages</a> (MESSAGE_ITERATOR itIn, uint_fast32_t numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a5dffd8924866931c4092ae85a869b49e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Minimum combine function.  <a href="#a5dffd8924866931c4092ae85a869b49e">More...</a><br /></td></tr>
<tr class="separator:a5dffd8924866931c4092ae85a869b49e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19259cb643dae0bcac418ca91ae55855"><td class="memItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtiglCombiner.html#a19259cb643dae0bcac418ca91ae55855">minCombineMessages</a> (ALG_MESSAGE_TYPE &amp;newMessage, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a19259cb643dae0bcac418ca91ae55855"><td class="mdescLeft">&#160;</td><td class="mdescRight">Minimum combine function for a single message.  <a href="#a19259cb643dae0bcac418ca91ae55855">More...</a><br /></td></tr>
<tr class="separator:a19259cb643dae0bcac418ca91ae55855"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename ALG_MESSAGE_TYPE&gt;<br />
class tiglCombiner&lt; ALG_MESSAGE_TYPE &gt;</h3>

<p>pure combiner class for the <a class="el" href="classTIGL.html" title="Top level class for the TIGL engine  . ">TIGL</a> engine </p>
<p>It contains the definitions of the combine function and has few template implementations It is a template class that is parameterized by </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ALG_MESSAGE_TYPE</td><td>the data field of pregel messages </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aecd9b18389735ebab5354a9a192e4020"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::combineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>core combine function for multiple messages. </p>
<p>It is an empty function that must be overridden by customized vertex definition for the different graph algorithms. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages. </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages. </dd></dl>

</div>
</div>
<a class="anchor" id="a753c1c8803743ac43e91f19975b30af2"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::combineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>core combine function from combining a single message. </p>
<p>It is an empty function that must be overridden by customized vertex definition for the different graph algorithms. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>the new message. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of messages after combining. </dd></dl>

</div>
</div>
<a class="anchor" id="a2206471de99d722dac790f6ed9b44d08"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::maxCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Maximum combine function. </p>
<p>It computes the maximum the data fields of all messages into a single message. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages. </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages (1 if there are messages, 0 if no messages). </dd></dl>

</div>
</div>
<a class="anchor" id="a075730c5510d5998da3e1200b3f3c7a5"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::maxCombineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Max combine function for adding a single message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the new message. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages. </dd></dl>

</div>
</div>
<a class="anchor" id="a5dffd8924866931c4092ae85a869b49e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::minCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Minimum combine function. </p>
<p>it computes the minimum the data fields of all messages into a single message. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages. </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages (1 if there are messages, 0 if no messages). </dd></dl>

</div>
</div>
<a class="anchor" id="a19259cb643dae0bcac418ca91ae55855"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::minCombineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Minimum combine function for a single message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the new message. </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa4eebe24c6a26fc98148940065ac9c5b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::sumCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sum combine function. </p>
<p>it sums the data fields of all messages into a single message </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages (1 if there are messages, 0 if no messages) </dd></dl>

</div>
</div>
<a class="anchor" id="ad9bacc561b203b7abe26a0175fe6d46a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classtiglCombiner.html">tiglCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::sumCombineMessages </td>
          <td>(</td>
          <td class="paramtype">ALG_MESSAGE_TYPE &amp;&#160;</td>
          <td class="paramname"><em>newMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>implementation of sum combine function for adding a single message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">newMessage</td><td>reference to the new message </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of combined output data messages </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/mohamed/code/tigl/src/common/api/<a class="el" href="tiglAPICombiner_8hpp_source.html">tiglAPICombiner.hpp</a></li>
<li>/home/mohamed/code/tigl/src/common/implementation/<a class="el" href="tiglImplementationCombiner_8hpp_source.html">tiglImplementationCombiner.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Mar 3 2015 18:10:44 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
